#include <allegro.h>
#include <tdgui.h>
#include <string.h>
#include <seer.h>
#define BYTE unsigned char
#include "mapc.h"
#include "map.h"
#define flip(bitmap) vsync(); blit(bitmap,screen,0,0,0,0,SCREEN_W,SCREEN_H)
//#define flip(bitmap,page,max) show_video_bitmap(bitmap[page]); page=(page+1)%max;

extern volatile BYTE sync;
extern volatile int stardate;

#include "land.h"
#include "mobs.h"
int going;
class mob *current=NULL;

typedef char labl [24];
int listsize=0;
int poolsize=0;
class mob *list=NULL;
class item *pool=NULL;
labl *strings=NULL;
   
char *listbox_getter(int index, int *list_size)
{
   if(current==NULL) {
     *list_size=0;
     return NULL;
     }
   int i=0;
   for(int j=0;j<poolsize;j++)       // go find all items belonging to current
     if(pool[j].mob_holding==current->id) i++;

   if (index < 0) {
      *list_size = i;
      return NULL;
     }
   if(strings!=NULL) {
     delete [] strings;
     strings=NULL;
     }
   
   strings=new labl [i];
   i=0;
   for(int j=0;j<poolsize;j++)
     if(pool[j].mob_holding==current->id)
       {
       strcpy(strings[i],pool[j].name);

       i++;
       }

   return strings[index];
}
int sgshow()
{
 char buf[200];
 billfile_select("Save your game", buf, NULL);
 return D_O_K;
}
int lgshow()
{
 char buf[200];
 billfile_select("Load your game", buf, NULL);
 return D_O_K;
}
int quit()
{
   if (billalert("Quit?", "Really want to quit?", NULL, "Yes", "Cancel", 'y', 27) == 1)
      {
      going=FALSE;
      return D_CLOSE;
      }
   else
      return D_O_K;
}
MENU my_menu[] =
{
   { "&Load\t(ctrl+L)",             lgshow,           NULL },
   { "&Save\t(ctrl+S)",             sgshow,            NULL },
   { "",                            NULL,             NULL },
   { "&Quit\t(ctrl+Q)",             quit,          NULL },
   { NULL,                          NULL,             NULL }
};

MENU menu[] =
{ 
   { "&File",                       NULL,             my_menu },
   { NULL,                          NULL,             NULL }
};
DIALOG the_dialog[] =
{
   /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
   { d_billwin_proc,       70,   70,   180,  120,  255,  0,    0,    0,       0,    0,    "Inventory"    },
   { d_billmenu_proc,      73,   85,   0,    0,    0,    0,    0,    0,       0,    0,    menu           },
   { d_billbutton_proc,    236,  73,   11,   10,   255,  0,    't',  D_EXIT,  0,    0,    "X"            },
   { d_billlist_proc,      122,  98,   118,  71,   255,  0,    0,    0,       0,    0,    listbox_getter },
   { d_billprogress_proc,  80,   176,  160,  6,    0,    0,    0,    0,       0,    0,    NULL           },
   { NULL,                 0,    0,    0,    0,    0,    0,    0,    0,       0,    0,    NULL           }
};


int
bar(BITMAP *d,int x,int y,int x2,int y2,long value,long total,int fc,int bc)
  {

  int s;
  int l=x2-x;
  if(total<=0) s=0;
  else if(value>total) s=0;
  else s=(value*l)/total;
  if(s<0) s=0;
  s+=x;
  if(s>x)
    for(int o=y;o<y2;o++)
      hline(d,x,o,s,fc);

  if(s<x2)
    for(int o=y;o<y2;o++)
      hline(d,s,o,x2,bc);

  return 1;
  }

land::light(int x,int y,int light) {
  icu(my_map,players_map,light,x,y,size.x,size.y,type);
  }

land::do_mouse(int si,int sj,vect &cm) {
    int cx=cm.x,cy=cm.y;

    if(mini_map==TRUE&&mouse_b&1&&mouse_x<si&&mouse_y<si&&(type==3||type==0)) {  // mini-map
      cx=(((mouse_x*size.x)/si)<<5)-SCREEN_W/2;
      cy=(((mouse_y*size.y)/sj)<<5)-SCREEN_H/2;
      }
    if(mouse_x+mouse_y<5) {cy-=15;cx-=15;}
      else if((SCREEN_W-mouse_x)+(SCREEN_H-mouse_y)<5) {cx+=15;cy+=15;}
      else if(mouse_x+(SCREEN_H-mouse_y)<5) {cx-=15;cy+=15;}
      else if((SCREEN_W-mouse_x)+mouse_y<5) {cx+=15;cy-=15;}
      else if(mouse_x<5) cx-=15;
      else if(mouse_y<5) cy-=15;
      else if(SCREEN_W-mouse_x<5) cx+=15;
      else if(SCREEN_H-mouse_y<5) cy+=15;
    if(cx<0) cx=0;
    if(cy<0) cy=0;
    if(cx>size.x*32-SCREEN_W) cx=size.x*32-SCREEN_W;
    if(cy>size.y*32-SCREEN_H) cy=size.y*32-SCREEN_H;
    cm.x=cx;
    cm.y=cy;
  }
land::draw_map(BITMAP *d,int x,int y,int sx,int sy) {
  if (type!=3&&type!=0) return -1;
  float pee1=float(size.y)/float(sy);
  float pee2=float(size.x)/float(sx);
  sy+=y;
  sx+=x;
  for(float ca=0,a=y;a<sy;a++,y++,ca+=pee1) {
    for(float cb=size.x*int(ca+0.5),b=x;b<sx;b++,cb+=pee2)
      if(players_map[int(ca+cb+0.5)]!=5) putpixel(d,int(b),int(a),players_map[int(cb)]+1);
      else putpixel(d,int(b),int(a),0);
    }

  }
land::go(BITMAP *dd) {
  going=TRUE;
  BITMAP *spr=create_bitmap(32,32);
  clear(spr);
  draw_rle_sprite(spr,(RLE_SPRITE *)Mp_data[pointer].dat,0,0);
  set_mouse_sprite(spr);
  InitSc();
  bill_init();
  bill_init_very_smallpal(248);
  set_gui_mode(TRUE);
  poolsize=52;
  pool=new item[poolsize];
  
  pool[0].mob_holding=none;
  pool[0].uses_left=weapon;
  pool[0].info.location.x=5;
  pool[0].info.location.y=15;
  pool[0].pict=sword1;
  pool[0].anim=1;     // six frames
  pool[1].mob_holding=none;
  pool[1].uses_left=noget;
  pool[1].info.location.x=5;
  pool[1].info.location.y=5;
  pool[1].pict=fire1;
  pool[1].anim=6;     // six frames
  for(int i=2;i<poolsize;i++) {
    pool[i].mob_holding=i-2;
    pool[i].info.useing=0;
    strcpy(pool[i].name,"Sword\0");
    strcpy(pool[i].type,"Weapon\0");
    pool[i].uses_left=weapon;
    pool[i].pict=sword1;
    pool[i].use.attack=5;
    pool[i].use.defence=1;
    pool[i].use.skill=2;
    pool[i].use.range=0;  // No added range bonus
    pool[i].use.life=0;   // no life gain using item
    }

  if(build()) return -1;
  if(my_map==NULL) return -1;
  vect cm={6,6};
  list=new mob[50](size);
  int i=0;
  for(int a=0;a<50;a++){
    list[a].location.x=rand()%size.x;
    list[a].location.y=rand()%size.x;
    if(a>25) {
      list[a].allignment=1;   // Give Half to each side... Just as a test
      if(list[a].brain!=NULL) scLaunch_Instance(list[a].brain,20,scGet_Symbol(list[a].brain,"main"));
      }
    list[a].pict=zombie1;
    if(!walk(my_map[list[a].location.x+list[a].location.y*size.x],type))
      a--;
    }
  listsize=50;

  stardate=0;
  int datadate=0;
  cm.x=(list[0].location.x<<5)-SCREEN_W/2;
  cm.y=(list[0].location.y<<5)-SCREEN_H/2;
  while(!key[KEY_ESC]&&going==TRUE) {
    sync=0;

    do_mouse(mini_size.x,mini_size.y,cm);                  // INPUT
    if(mouse_b&2&&current!=NULL&&current->allignment==0) {
      current->dest.x=(mouse_x+cm.x)>>5;
      current->dest.y=(mouse_y+cm.y)>>5;
      if(current->location.x==current->dest.x&&current->location.y==current->dest.y) {
        for(int a=0;a<poolsize;a++)
          pool[a].dis(object_map,size.x,i);

        for(int a=0;a<listsize;a++)
          list[a].dis(mob_map,size.x);

        dis(dd,cm.x,cm.y);
        flip(dd);
        init_moveable(the_dialog);
        do_dialog (the_dialog, 0);
        shutdown_moveable(the_dialog);
        show_mouse(NULL);
        }
      }
    if(mouse_b&1) {
     for(int a=0;a<listsize;a++)
      if(list[a].location.x==(mouse_x+cm.x)>>5&&list[a].location.y==(mouse_y+cm.y)>>5)
        current=&list[a];
      }
    if(hidden_areas==TRUE) {                               // PROCESS DATA
      memset(players_map,5,size.x*size.y);
      for(int a=0;a<listsize;a++)
       if(list[a].allignment==0)
        light(list[a].location.x,list[a].location.y,3);
      }
    scContinue_Instances(); // Run Mob AI!

    for(int a=0;a<poolsize;a++)
      pool[a].dis(object_map,size.x,i);
    i++;

    for(int a=0;a<listsize;a++)
      list[a].dis(mob_map,size.x);

    if(stardate>10) {
      for(int a=0;a<listsize;a++) {
        list[a].go_to(my_map,mob_map,type,size);
        list[a].step(mob_map,size.x);  // This draws them on the map too
        }
      stardate=0;
      datadate++;
      }
    if(datadate>15) {
      for(int a=0;a<listsize;a++)
        list[a].do_stats();
      datadate=0;
      }
    if((type!=0&&type!=3)||hidden_areas==TRUE) clear(dd);      // OUTPUT
    dis(dd,cm.x,cm.y);
    if(current!=NULL) {
     if(current->allignment==0) {
        rect(dd,(current->location.x<<5)-((RLE_SPRITE *)Mp_data[current->pict].dat)->w-cm.x+31,(current->location.y<<5)-((RLE_SPRITE *)Mp_data[current->pict].dat)->h-cm.y+31,(current->location.x<<5)+33-cm.x,(current->location.y<<5)+37-cm.y,255);
        bar(dd,(current->location.x<<5)-((RLE_SPRITE *)Mp_data[current->pict].dat)->w-cm.x+32,(current->location.y<<5)+33-cm.y,(current->location.x<<5)+32-cm.x,(current->location.y<<5)+37-cm.y,current->current.life,current->normal.life,44,56);
        }
      else {
        rect(dd,(current->location.x<<5)-((RLE_SPRITE *)Mp_data[current->pict].dat)->w-cm.x+31,(current->location.y<<5)-((RLE_SPRITE *)Mp_data[current->pict].dat)->h-cm.y+31,(current->location.x<<5)+33-cm.x,(current->location.y<<5)+37-cm.y,64);
        bar(dd,(current->location.x<<5)-((RLE_SPRITE *)Mp_data[current->pict].dat)->w-cm.x+32,(current->location.y<<5)+33-cm.y,(current->location.x<<5)+32-cm.x,(current->location.y<<5)+37-cm.y,current->current.life,current->normal.life,44,56);
        if(players_map[current->location.x+current->location.y*size.x]==5) current=NULL; // You can't see it anymore
        }
     }
    //if(mini_map==TRUE) draw_map(dd,mini_pos.x,mini_pos.y,mini_size.x,mini_size.y);

    if(key[KEY_F1]) {
      PALETTE pal;
          
      get_palette(pal);
      save_bitmap("dump.bmp", dd, pal);
      }

    draw_pointer(dd);

    flip(dd);
    while(sync==0);
    }
  while(key[KEY_ESC]);

  set_mouse_sprite(NULL);
  destroy_bitmap(spr);
  KillSc();
  delete [] pool;
  delete [] list;
  if(strings!=NULL) delete [] strings;
  }
land::dis(BITMAP *d,int x,int y) {
  if(type==0||type==3) display_layered_map(d,players_map,object_map,mob_map,x,y,size.x,size.y);
  else {
    display_dung(d,players_map,x,y,size.x,size.y);
    display_dung(d,object_map,x,y,size.x,size.y);
    display_dung(d,mob_map,x,y,size.x,size.y);
    }
  memset(object_map,5,size.x*size.y);
  memset(mob_map,5,size.x*size.y);
  }
land::build() {
  if(my_map!=NULL) delete [] my_map;
  if(mob_map!=NULL) delete [] mob_map;
  if(object_map!=NULL) delete [] object_map;
  if(players_map!=NULL) delete [] players_map;
  my_map=new BYTE[size.x*size.y];
  players_map=new BYTE[size.x*size.y];
  mob_map=new BYTE[size.x*size.y];
  object_map=new BYTE[size.x*size.y];
  memset(players_map,5,size.x*size.y);
  memset(object_map,5,size.x*size.y);
  memset(mob_map,5,size.x*size.y);
  int i=-1;
  switch(type) {
    case 0:
      i=generate_map(my_map,seed,size.x,size.y,size.x*size.y);
      break;
    case 1:
      if(size.x%2!=0) size.x--; // Size needs to be odd for the maze
      if(size.y%2!=0) size.y--;
      i=generate_dung(my_map,seed,size.x,size.y,(size.x*size.y)/400);
      break;
    case 2:
      i=gen_maze(my_map,seed,size.x,size.y);
      break;
    case 3:
      //i=generate_frac_map(my_map,seed,size.x,size.y,0.8); // 'tis buged!!!
      break;
    };
  if(hidden_areas==FALSE) memcpy(players_map,my_map,size.x*size.y);

  return i; // if (i==-1) ERROR of stupidness
  };
int land::pal_number=-1;
int land::total=0;
land::land() {
  type=0;
  name[0]=0;
  mini_map=FALSE;
  hidden_areas=FALSE;
  my_map=players_map=mob_map=object_map=NULL;
  mini_pos.x=mini_pos.y=0;
  mini_size.x=SCREEN_W/5;
  mini_size.y=SCREEN_W/5;
  seed=42;        // A special number ;)
  size.x=size.y=100;
  if(total==0) {
    map_init();
    }
  total++;
  };
land::~land() {
  if(my_map!=NULL) delete my_map;
  if(players_map!=NULL) delete players_map;
  if(object_map!=NULL) delete object_map;
  if(mob_map!=NULL) delete mob_map;
  total--;
  if(total==0) {
    map_exit();
    }
  };

land::check_pal() {
  if(pal_number!=type) { // change palette
    fade_out(5);
    clear(screen);
    set_map_pal();
    }
  return 0;
  };
land::draw_pointer(BITMAP *d) {
  draw_rle_sprite(d,(RLE_SPRITE *)Mp_data[pointer].dat,mouse_x,mouse_y);
  return 0;
  };
