#ifndef LAND_H
#define LAND_H

struct vect {
  int x,y;
  };

class land {
  public:
    int mini_map;
    char name[20];
    int seed;
    int hidden_areas;
    static int total;
    static int pal_number;
    BYTE *my_map;
    BYTE *players_map;
    BYTE *object_map;
    BYTE *mob_map;
    vect size;
    vect mini_pos;
    vect mini_size;
    land();
    ~land();
    int type;                  /// TYPE of map!!!
    build();                   /// build the map
    dis(BITMAP *d,int x,int y);/// display map from x,y
    check_pal();               /// check we are using the right palette
    go(BITMAP *dd);             // handle map
    draw_pointer(BITMAP *d);// draw pointer
    draw_man(BITMAP *d,int x,int y,int face); // draw man
    draw_map(BITMAP *d,int x,int y,int sx,int sy);
    do_mouse(int si,int sj,vect &cm);
    light(int x,int y,int light);
};
#endif
